package models

import (
	"errors"

	"github.com/lib/pq"
)

func IsDuplicateError(err error) bool {
	var pqErr *pq.Error
	if errors.As(err, &pqErr) {
		switch pqErr.Code {
		case "23505":
			// unique constraint violation
			return true

		default:
			return false
		}
	}

	return false
}
